' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2007/02/23 
' -----------------------------------------------------------------

Imports System.Windows.Forms.DialogResult
Imports System.IO
Imports FVDATASLib
Imports Microsoft

Public Class frmBlobResult

    Private Const PI As Double = 3.14159265358979

    'SBlob
    Public intMaxBlobNo As Integer

    'ݕ\ĂBlobNo.
    Private m_intBlobNo As Integer

    Private Sub frmBlobResult_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        m_intBlobNo = 0
        txtAllBlobNo.Text = intMaxBlobNo.ToString()
        DrawOne(m_intBlobNo)

    End Sub

    '
    Private Sub btnNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNext.Click

        m_intBlobNo = m_intBlobNo + 1
        If m_intBlobNo > intMaxBlobNo Then m_intBlobNo = intMaxBlobNo

        DrawOne(m_intBlobNo)

    End Sub

    'O
    Private Sub btnBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBack.Click

        m_intBlobNo = m_intBlobNo - 1
        If m_intBlobNo < 0 Then m_intBlobNo = 0

        DrawOne(m_intBlobNo)

    End Sub

    '1Blob`
    Private Sub DrawOne(ByVal intNum As Integer)

        Dim pBlobResult As New FvBlobResult
        Dim pBox As New FvRectangle

        txtBlobNo.Text = intNum.ToString()

        With frmDisplayEx
            'I[o[Cʂ̏
            .AxFvxDisplayEx1.ClearOverlay()

            '͈͂𔖐ŕ\
            .AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 192, 192)
            .AxFvxDisplayEx1.DrawData(0, frmMain.m_BlobExeRegion)

            'u[uڍ׏擾
            frmMain.AxFvxBlob1.GetResult(intNum, pBlobResult)
        End With

        'u[ȕڍׂȏeLXg{bNXɕ\
        txtResult.Text = _
            "܂܂Ȃʐ : " & VisualBasic.Format(pBlobResult.area, "0.00") & vbCrLf & _
            " : " & VisualBasic.Format(pBlobResult.hole_num, "0.00") & vbCrLf & _
            "͒ : " & VisualBasic.Format(pBlobResult.perim, "0.00") & vbCrLf & _
            "ȉ~厲 : " & VisualBasic.Format(pBlobResult.ellipse_long, "0.00") & vbCrLf & _
            "ȉ~ : " & VisualBasic.Format(pBlobResult.ellipse_short, "0.00") & vbCrLf & _
            "ȉ~XΊp : " & VisualBasic.Format(pBlobResult.ellipse_angle, "0.00") & vbCrLf & _
            "dSW : ( " & VisualBasic.Format(pBlobResult.center_x, "0.00") & _
                " , " & VisualBasic.Format(pBlobResult.center_y, "0.00") & " )" & vbCrLf & _
            "Xŏl : " & VisualBasic.Format(pBlobResult.x_min, "0.00") & vbCrLf & _
            "Xől : " & VisualBasic.Format(pBlobResult.x_max, "0.00") & vbCrLf & _
            "Yŏl : " & VisualBasic.Format(pBlobResult.y_min, "0.00") & vbCrLf & _
            "Yől : " & VisualBasic.Format(pBlobResult.y_max, "0.00") & vbCrLf & _
            "܂߂ʐ : " & VisualBasic.Format(pBlobResult.total_area, "0.00") & vbCrLf & _
            "Oڒ`  : ( " & VisualBasic.Format(pBlobResult.bounding_top_x, "0.00") & _
                " , " & VisualBasic.Format(pBlobResult.bounding_top_y, "0.00") & " )" & vbCrLf & _
            "Oڒ` E : ( " & VisualBasic.Format(pBlobResult.bounding_right_x, "0.00") & _
                " , " & VisualBasic.Format(pBlobResult.bounding_right_y, "0.00") & " )" & vbCrLf & _
            "Oڒ`  : ( " & VisualBasic.Format(pBlobResult.bounding_left_x, "0.00") & _
                " , " & VisualBasic.Format(pBlobResult.bounding_left_y, "0.00") & " )" & vbCrLf & _
            "Oڒ` E : ( " & VisualBasic.Format(pBlobResult.bounding_right_x, "0.00") & _
                " , " & VisualBasic.Format(pBlobResult.bounding_right_y, "0.00") & " )" & vbCrLf

        'F = 
        frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)

        'tFa\
        pBox.xs = pBlobResult.x_min
        pBox.ys = pBlobResult.y_min
        pBox.xe = pBlobResult.x_max
        pBox.ye = pBlobResult.y_max

        frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pBox)

    End Sub

    'LZ
    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click

        Me.Close()

    End Sub

    'p^o^ďI
    Private Sub btnSetPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetPattern.Click

        Dim pBlobResult As New FvBlobResult
        Dim pBox As New FvRectangle
        Dim pPoint As New FvPoint

        'u[uڍ׏擾
        frmMain.AxFvxBlob1.GetResult(m_intBlobNo, pBlobResult)
        pBox.xs = pBlobResult.x_min
        pBox.ys = pBlobResult.y_min
        pBox.xe = pBlobResult.x_max
        pBox.ye = pBlobResult.y_max

        '񓚊_p^̈̒ɐݒ
        pPoint.x = (pBlobResult.x_min + pBlobResult.x_max) / 2
        pPoint.y = (pBlobResult.y_min + pBlobResult.y_max) / 2

        frmMain.AxFvxPattern1.MakePattern(frmMain.AxFvxImageGray.GetOcx(), pBox, pPoint)

        Me.Close()

    End Sub
End Class